## hime 0.9.10

=== Makefile ===
include config.mak

VERSION_FILE = ChangeLog

DIR    = src data filter scripts icons man menu

ifeq ($(ECHO),)
ECHO  := $(shell whereis -b echo | awk '{print $$2}')
ifeq ($(ECHO),)
ECHO   = echo
endif
endif

ifeq ($(USE_I18N),Y)
DIR   += po
endif


all:
	@for d in $(DIR); do $(ECHO) -e "\x1b[1;33m** processing $$d\x1b[0m"; \
	   $(MAKE) -C $$d || exit 1; \
	done

install:
	@for d in $(DIR); do $(ECHO) -e "\x1b[1;32m** installing $$d\x1b[0m"; \
	   $(MAKE) -C $$d install || exit 1; \
	done
	@if [ "$(prefix)" = /usr/local ]; then \
	   install -d $(DOC_DIR); \
	   install -m 644 ChangeLog $(DOC_DIR); \
	else \
	   install -d $(DOC_DIR_i); \
	   install -m 644 ChangeLog $(DOC_DIR_i); \
	fi

clean:
	@touch src/.depend
	@for d in $(DIR); do $(ECHO) -e "\x1b[1;31m** cleanup $$d\x1b[0m"; \
	   $(MAKE) -C $$d clean; \
	done

distclean:
	@$(MAKE) clean
	@rm -f config.mak

config.mak: $(VERSION_FILE) configure
	@$(ECHO) "regenerate $@ ..."
	./configure

=== data/Makefile ===
include ../config.mak

SRC_DIR       = ../src
IM_CLIENT_DIR = $(SRC_DIR)/im-client

.SUFFIXES:	.kbmsrc .kbm .cin .gtab
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I$(SRC_DIR)
export HIME_NO_RELOAD=

DATA=pho.tab2 tsin32.idx gtab.list \
     cj.gtab ar30.gtab ar30-big.gtab pinyin.gtab jyutping.gtab cj5.gtab \
     et.kbm et26.kbm zo.kbm pinyin.kbm dvorak.kbm mitac.kbm colemak.kbm \
     ibm.kbm tsin32 hsu.kbm pho-huge.tab2 simplex.gtab symbols.gtab russian.gtab \
     greek.gtab cj-punc.gtab latin-letters.gtab tsin-1.src pin-juyin.xlt \
     t2s.dat s2t.dat cj543.gtab s-tsin32 s-tsin32.idx s-pho.tab2 s-pho-huge.tab2 \
     pinyin-no-tone.kbm simplex-punc.gtab hangul.gtab

DATAKEEP = symbol-table phrase.table phrase-ctrl.table

PHO_A2D    = $(SRC_DIR)/hime-phoa2d
TS_A2D     = $(SRC_DIR)/hime-tsa2d32
CIN2GTAB   = $(SRC_DIR)/hime-cin2gtab
KBMCV      = $(SRC_DIR)/kbmcv
PIN_JUYIN  = $(SRC_DIR)/pin-juyin

ifeq ($(USE_TSIN),Y)
REMOVE_TSIN = keep_tsin
endif

ifeq ($(USE_TSIN),N)
REMOVE_TSIN = remove_tsin
endif

ifeq ($(INSTALL_DFSG_INCOMPATIBLE),Y)
DATA += dayi3.gtab
endif

all:	$(DATA)

$(PHO_A2D):
	$(MAKE) -C $(SRC_DIR) hime-phoa2d

$(TS_A2D):
	$(MAKE) -C $(SRC_DIR) hime-tsa2d32

$(CIN2GTAB):
	$(MAKE) -C $(SRC_DIR) hime-cin2gtab

$(KBMCV):
	$(MAKE) -C $(SRC_DIR) kbmcv

$(PIN_JUYIN):
	$(MAKE) -C $(SRC_DIR) pin-juyin

tsin32:	tsin.src  $(TS_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(TS_A2D) $<
tsin32.idx:	tsin32


s-tsin32:	s-tsin.src  $(TS_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(TS_A2D) $< $@
s-tsin32.idx:	s-tsin32


pho.tab2:	 pho.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

s-pho.tab2:	 s-pho.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

pho-huge.tab2:	 pho-huge.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

s-pho-huge.tab2:	 s-pho-huge.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

t2s.dat:	t2s-file t2s-file.table
	./t2s-file
s2t.dat:	t2s-file

pin-juyin.xlt: $(PIN_JUYIN) pin-juyin.src
	$(PIN_JUYIN)

extr1:	extr1.c
	@echo "building $@ ..."
	@$(CC) $(CFLAGS) $< $(SRC_DIR)/util.o $(SRC_DIR)/locale.o -o $@ $(LDFLAGS)

t2s-file:	t2s-file.c
	@echo "building $@ ..."
	@$(CC) $(CFLAGS) $< $(SRC_DIR)/util.o $(SRC_DIR)/locale.o -o $@ $(LDFLAGS)

tsin-1.src:	extr1
	./extr1 > $@

.cin.gtab: $(CIN2GTAB)
	$(CIN2GTAB) $<

.kbmsrc.kbm: $(KBMCV)
	$(KBMCV) $<

keep_tsin: gtab.list.in
	cp gtab.list.in gtab.list

remove_tsin: gtab.list.in
	grep -v TSIN gtab.list.in > gtab.list

gtab.list: $(REMOVE_TSIN)
	touch gtab.list

install:
	install -d $(HIME_TABLE_DIR_i)
	install -m 644 $(DATA) $(DATAKEEP) $(HIME_TABLE_DIR_i)
#	cd $(HIME_TABLE_DIR_i); bzip2 -f *.gtab

clean:
	@echo "clean up"
	@rm -f *~ tags core.* $(DATA) *.gtab extr1 t2s-file tsin-1.src tsin-gtabidx* tsin-ch-idx gtab.list

=== src/Makefile ===

include ../config.mak

CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I./IMdkit/include -I./im-client \
        -DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
        -DHIME_OGG_DIR=\"$(HIME_OGG_DIR)\" \
        -DDOC_DIR=\"$(DOC_DIR)\" \
        -DHIME_ICON_DIR=\"$(HIME_ICON_DIR)\" \
        -DHIME_SCRIPT_DIR=\"$(HIME_SCRIPT_DIR)\" -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" \
        -DSYS_ICON_DIR=\"$(SYS_ICON_DIR)\" -DFREEBSD=$(FREEBSD) -DMAC_OS=$(MAC_OS) \
        -DHIME_VERSION=\"$(shell head -n 1 ../ChangeLog)\" \
        -DG_DISABLE_SINGLE_INCLUDES -DG_DISABLE_DEPRECATED \
        -DGDK_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
        -DGTK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED -DGSEAL_ENABLE

OBJ_IMSRV = im-addr.o im-dispatch.o im-srv.o hime-crypt.o

hime_pho_o  = win-pho.o pho.o pho-util.o pho-sym.o table-update.o pho-dbg.o
hime_gtab_o = gtab.o win-gtab.o gtab-util.o gtab-list.o gtab-buf.o


OBJS      = hime.o eve.o util.o hime-conf.o hime-settings.o locale.o \
	hime-icon.o about.o \
	hime-exec-script.o pho-play.o cache.o gtk_bug_fix.o \
	phrase-save-menu.o \
	$(hime_pho_o) $(hime_gtab_o) \
	hime-common.o phrase.o t2s-lookup.o gtab-use-count.o \
	win-save-phrase.o unix-exec.o pho-kbm-name.o statistic.o tsin-scan.o \
	hime-module.o lang.o \
	hime-module-cb.o gtab-init.o fullchar.o gtab-tsin-fname.o \
	win-message.o win-sym.o win-inmd-switch.o pinyin.o \
	win-pho-near.o win-kbm.o pho2pinyin.o

OBJS_TSLEARN = hime-tslearn.o util.o hime-conf.o pho-util.o tsin-util.o \
	pho-sym.o table-update.o locale.o \
	hime-settings.o hime-common.o hime-icon.o pho-dbg.o \
	pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
	gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_TS_EDIT = hime-ts-edit.o util.o hime-conf.o pho-util.o tsin-util.o \
	pho-sym.o table-update.o locale.o \
	hime-settings.o hime-common.o hime-icon.o pho-dbg.o \
	pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
	gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_JUYIN_LEARN = hime-juyin-learn.o locale.o util.o pho-util.o pho-sym.o \
	pho2pinyin.o hime-settings.o hime-conf.o table-update.o pinyin.o \
	hime-icon.o pho-dbg.o

OBJS_hime-sim2trad = hime-sim2trad.o util.o locale.o hime-conf.o hime-icon.o t2s-lookup.o

OBJS_hime-phod2a = hime-phod2a.o pho-util.o hime-conf.o pho-sym.o table-update.o \
	pho-dbg.o locale.o hime-settings.o util.o

OBJS_hime-tsa2d32 = hime-tsa2d32.o util.o pho-sym.o hime-conf.o \
	locale.o pho-lookup.o pinyin.o pho2pinyin.o pho-dbg.o

OBJS_hime-phoa2d = hime-phoa2d.o pho-sym.o hime-conf.o locale.o \
	pho-lookup.o util.o pho-dbg.o

OBJS_kbmcv = kbmcv.o pho-sym.o util.o locale.o

OBJS_hime-tsd2a32 = hime-tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o \
	gtab-dbg.o pho2pinyin.o hime-conf.o pinyin.o

OBJS_cin2gtab     = hime-cin2gtab.o gtab-util.o util.o locale.o
OBJS_gtab2cin     = hime-gtab2cin.o gtab-util.o util.o locale.o
OBJS_gtab_merge   = hime-gtab-merge.o gtab-util.o util.o locale.o
OBJS_hime_setup   = hime-setup.o hime-conf.o util.o hime-settings.o \
	hime-setup-list.o locale.o hime-setup-pho.o about.o \
	lang.o hime-icon.o hime-setup-gtab.o hime-setup-appearance.o gtab-list.o hime-exec-script.o \
	pho-kbm-name.o hime-module-cb.o

OBJS_hime_gb_toggle  = hime-gb-toggle.o  hime-conf.o util.o
OBJS_hime_message    = hime-message.o    hime-conf.o util.o

OBJS_pin_juyin       = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o

OBJS_tsin2gtab_phrase = hime-tsin2gtab-phrase.o hime-conf.o util.o locale.o \
	pho-dbg.o pho-sym.o gtab-dbg.o lang.o


#WALL=-Wall

ifeq ($(USE_XIM),Y)
IMdkitLIB   = IMdkit/lib/libXimd.a
CFLAGS     += -DUSE_XIM=1
OBJS       += IC.o
endif

ifeq ($(USE_TRAY),Y)
CFLAGS     += -DTRAY_ENABLED=1
OBJS       += tray.o tray-double.o
ifeq ($(GTK),gtk+-2.0)
OBJS       += gdkpixbuf-drawable.o
endif
ifeq ($(USE_UNITY),Y)
CFLAGS     += -DTRAY_UNITY=1
OBJS       += tray-appindicator.o
endif
endif

ifeq ($(USE_I18N),Y)
CFLAGS     += -DHIME_i18n_message=1
endif

ifeq ($(USE_TSIN),Y)
hime_tsin_o = tsin.o tsin-util.o win0.o win1.o tsin-parse.o
CFLAGS     += -DUSE_TSIN=1
OBJS       += $(hime_tsin_o)
endif

# Temporary workaround to turn off Tsin, will be fixed later
ifeq ($(USE_TSIN),N)
OBJS       += tsin.o tsin-util.o win0.o win1.o tsin-parse.o
endif

ifeq ($(MAC_OS),1)
EXTRA_LDFLAGS=-bind_at_load 
endif

ifeq ($(GIT_HAVE),Y)
CFLAGS     += -DGIT_HASH=\"$(GIT_HASH)\" -DGIT_HAVE=1
endif

PROGS     = hime \
	hime-tsd2a32 hime-tsa2d32 hime-phoa2d hime-phod2a \
	hime-tslearn hime-setup hime-cin2gtab hime-gtab2cin \
	hime-juyin-learn hime-sim2trad hime-gb-toggle hime-message hime-gtab-merge \
	hime-tsin2gtab-phrase hime-ts-edit

PROGS_SYM = hime-trad2sim hime-exit hime-sim hime-trad hime-kbm-toggle

PROGS_CV  = kbmcv pin-juyin

.SUFFIXES:  .c .o .E .pico .cpp

.cpp.o:
	@echo "  $< -> $@"
	@$(CCX) $(CPPFLAGS) $(CFLAGS) -c $<
.c.o:
	@echo "  $< -> $@"
	@$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
.c.pico:
	@echo "  $< -> $@"
	@$(CC) $(CPPFLAGS) $(CFLAGS) -c -fpic -o $@ $<
.cpp.pico:
	@echo "  $< -> $@"
	@$(CCX) $(CPPFLAGS) $(CFLAGS) -c -fpic -o $@ $<
.c.E:
	@echo "  $< -> $@"
	@$(CC) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<
.cpp.E:
	@echo "  $< -> $@"
	@$(CCX) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<


all: $(PROGS) $(PROGS_SYM) $(DATA) $(PROGS_CV)
	$(MAKE) -C modules
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi

$(IMdkitLIB):
	@echo "building $@ ..."
	$(MAKE) -C IMdkit/lib

im-client/libhime-im-client.so:
	@echo "building $@ ..."
	$(MAKE) -C im-client

hime: $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	@echo "linking $@ ..."
ifeq ($(FREEBSD), 0)
	@$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
else
	@$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/local/$(LIB)
endif
	@rm -f core.* vgcore.*

hime-tslearn: $(OBJS_TSLEARN) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-ts-edit: $(OBJS_TS_EDIT) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-juyin-learn: $(OBJS_JUYIN_LEARN)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)
	@rm -f core.*

hime-sim2trad: $(OBJS_hime-sim2trad)
	@echo "linking $@ ..."
	@$(CC) $(gcc_ld_run_path) -o $@ $^ $(LDFLAGS)
	@rm -f core.*

hime-trad2sim:  hime-sim2trad
	ln -sf hime-sim2trad $@

hime-setup: $(OBJS_hime_setup) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@rm -f core.*
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-phoa2d: $(OBJS_hime-phoa2d) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-phod2a: $(OBJS_hime-phod2a)
	@echo "linking $@ ..."
	@$(CCLD) -lX11 -o $@ $^ $(LDFLAGS)

hime-tsa2d32:  $(OBJS_hime-tsa2d32) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

#hime-tsd2a:
#	$(CCLD) -o $@ $(LDFLAGS)

hime-tsd2a32: $(OBJS_hime-tsd2a32)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)


hime-cin2gtab: $(OBJS_cin2gtab)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)
	@rm -f data/*.gtab

hime-gtab2cin: $(OBJS_gtab2cin)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

hime-gtab-merge: $(OBJS_gtab_merge)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

kbmcv: $(OBJS_kbmcv)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

hime-gb-toggle: $(OBJS_hime_gb_toggle) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-kbm-toggle: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-exit: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-trad: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-sim: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-message: $(OBJS_hime_message) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

pin-juyin: $(OBJS_pin_juyin)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

hime-tsin2gtab-phrase: $(OBJS_tsin2gtab_phrase)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

install:
	install -d $(bindir)
	install $(PROGS) $(bindir)
	rm -f $(bindir)/hime-trad2sim; ln -sf hime-sim2trad $(bindir)/hime-trad2sim
	rm -f $(bindir)/hime-exit; ln -sf hime-gb-toggle $(bindir)/hime-exit
	rm -f $(bindir)/hime-trad; ln -sf hime-gb-toggle $(bindir)/hime-trad
	rm -f $(bindir)/hime-sim; ln -sf hime-gb-toggle $(bindir)/hime-sim
	rm -f $(bindir)/hime-kbm-toggle; ln -sf hime-gb-toggle $(bindir)/hime-kbm-toggle
	install -d $(himelibdir)
	install -d $(includedir)
	install -m 644 im-client/hime-im-client.h im-client/hime-im-client-attr.h $(includedir)
	$(MAKE) -C im-client install
	$(MAKE) -C modules install
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im install; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im install; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi

clean:
	@echo "clean up"
	$(MAKE) -C IMdkit clean
	$(MAKE) -C im-client clean
	$(MAKE) -C modules clean
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im clean; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im clean; fi
	$(MAKE) -C qt-im clean
	$(MAKE) -C qt4-im clean
	@rm -f *.o *.E *.db *.pico *.so tags $(PROGS) $(PROGS_CV) \
		$(DATA) .depend $(PROGS_SYM) hime.log hime-fedora.spec
	@find . '(' -name '.ted*' -o -name '*~' -o -name 'core.*' -o -name 'vgcore.*' ')' -exec rm {} \;

.depend:
	@echo "building $@ ..."
	@$(CCX) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@



include .depend

=== src/gtk-im/Makefile ===
include ../../config.mak

OBJS = imhime.o gtkimcontexthime.o
GTK2IM=gtk-2.0/immodules
GTKINC=`pkg-config --cflags gtk+-2.0`
LDFLAGS=`pkg-config --libs gtk+-2.0`
GTK_LIBDIR=`pkg-config --variable=libdir gtk+-2.0`
GTK_BINARY_VERSION=`pkg-config --variable=gtk_binary_version gtk+-2.0`
MODULEDIR=$(DESTDIR)/$(GTK_LIBDIR)/gtk-2.0/$(GTK_BINARY_VERSION)/immodules
IMMODULES=$(libdir)/$(GTK2IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK2IM)
IMMODULES_QUERY=`whereis gtk-query-immodules-2.0 | cut -d ' ' -f 2`


ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	@echo "  $< -> $@"
	@$(CC) -c -fPIC $(CPPFLAGS) $(CFLAGS) -o $@ $<

.c.E:
	@echo "  $< -> $@"
	@$(CC) -E $(CPPFLAGS) $(CFLAGS) -o $@ $<

all:	im-hime.so

im-hime.so:     $(OBJS) ../im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lhime-im-client -o $@ $(LDFLAGS)
	@rm -f core.*

clean:
	@echo "clean up"
	@rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
		install -d $(MODULEDIR); \
		install -m 755 im-hime.so $(MODULEDIR); \
		if [ "$(prefix)" = "/usr/local" ]; then \
			if [ -d $(DESTDIR)/etc/gtk-2.0 ]; then \
				cd $(DESTDIR)/etc/gtk-2.0; $(IMMODULES_QUERY) > gtk.immodules; \
			fi \
		fi \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-hime.so $(IMMODULES); \
	fi

.depend:
	@echo "building $@ ..."
	@$(CC) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== src/gtk3-im/Makefile ===
include ../../config.mak

OBJS = imhime.o gtkimcontexthime.o
GTK3IM=gtk-3.0/immodules
GTKINC=`pkg-config --cflags gtk+-3.0`
LDFLAGS=`pkg-config --libs gtk+-3.0`
GTK3_LIBDIR=`pkg-config --variable=libdir gtk+-3.0`
GTK3_BINARY_VERSION=`pkg-config --variable=gtk_binary_version gtk+-3.0`
MODULEDIR=$(DESTDIR)/$(GTK3_LIBDIR)/gtk-3.0/$(GTK3_BINARY_VERSION)/immodules
IMMODULES=$(libdir)/$(GTK3IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK3IM)
IMMODULES_QUERY=$(shell whereis gtk-query-immodules-3.0 | awk -F ' = ' '{print $2}')
IMMODULES_CACHE=$(DESTDIR)/$(GTK3_LIBDIR)/gtk-3.0/$(GTK3_BINARY_VERSION)/immodules.cache

ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	@echo "  $< -> $@"
	@$(CC) -c -fPIC $(CPPFLAGS) $(CFLAGS) -o $@ $<

.c.E:
	@echo "  $< -> $@"
	@$(CC) -E $(CPPFLAGS) $(CFLAGS) -o $@ $<

all:	im-hime.so

im-hime.so:     $(OBJS) ../im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lhime-im-client -o $@ $(LDFLAGS)
	@rm -f core.*

clean:
	@echo "clean up"
	@rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
		install -d $(MODULEDIR); \
		install -m 755 im-hime.so $(MODULEDIR); \
		if [ "$(prefix)" = "/usr/local" ]; then \
			if [ -f "$(IMMODULES_QUERY)" -a -x "$(IMMODULES_QUERY)" ]; then \
				GTK_IM_MODULE_FILE=$(IMMODULES_CACHE) $(IMMODULES_QUERY) --update-cache; \
			fi \
		fi \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-hime.so $(IMMODULES); \
	fi

.depend:
	@echo "building $@ ..."
	@$(CC) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== src/im-client/Makefile ===
include ../../config.mak

SOFILE=libhime-im-client.so
SOFILEVER=libhime-im-client.so.1.2.4

.SUFFIXES:      .c .o .E .cpp
WALL=-Wall
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) -I. -I.. -I../IMdkit/include $(GTKINC) \
        -DCLIENT_LIB=1 -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" -DUNIX=1 \
        -DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
        -DFREEBSD=$(FREEBSD) -fPIC
OBJS = hime-im-client.o hime-send.o im-addr.o hime-conf.o util.o hime-crypt-fpic.o

.cpp.E:
	@echo "  $< -> $@"
	@$(CC) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<

.c.o:
	@echo "  $< -> $@"
	@$(CC) -c $(CPPFLAGS) $(CFLAGS) $<

.cpp.o:
	@echo "  $< -> $@"
	@$(CC) -x c -c $(CPPFLAGS) $(CFLAGS) $<

$(SOFILEVER):   $(OBJS)
	@echo "linking $@ ..."
# TODO: Drop g_get_tmp_dir() and -lglib-2.0
ifeq ($(FREEBSD), 0)
	@$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/X11R6/lib
else
	@$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/local/lib
endif
	ln -sf $(SOFILEVER) $(SOFILE)
	ln -sf $(SOFILEVER) $(SOFILE).1
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C ../gtk-im; fi

LOCALLIB=/usr/local/$(LIB)

install:
	install -d $(himelibdir)
	install -m 755 $(SOFILEVER) $(himelibdir)
	cd $(himelibdir); rm -f $(SOFILE); ln -s $(SOFILEVER) $(SOFILE); \
	ln -sf $(SOFILEVER) $(SOFILE).1

hime-conf.o: ../hime-conf.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

util.o: ../util.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

im-addr.o: ../im-addr.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

hime-crypt-fpic.o: ../hime-crypt.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

clean:
	@echo "clean up"
	@rm -f *.o *.so *.so.* *~ *.E *.db tags core.* .depend

.depend:
	@echo "building $@ ..."
	@$(CCX) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== src/qt-im/Makefile ===
include ../../config.mak
QT=qt3
QTIM=$(QT)/plugins/inputmethods
IMMODULES=$(libdir)/$(QTIM)
INCS=-I../im-client -I/usr/include `pkg-config --cflags qt-mt` -I/usr/include/Xft2/X11/Xft  -I/usr/include/fontconfig -I/usr/include/freetype2
CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT_THREAD_SUPPORT -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG
OBJS=qhimeinputcontextplugin.o qhimeinputcontextplugin_my.o qhimeinputcontext.o qhimeinputcontext_x11.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS=$(LDFLAGS_ENV) -L../im-client -lhime-im-client -Wl,-rpath,$(himelibdir) `pkg-config qt-mt --libs`
all:	im-hime.so

.cpp.E:
	@echo "  $< -> $@"
	@$(CXX) -E $(CFLAGS) $(INCS) $< > $@

.cpp.o:
	@echo "  $< -> $@"
	@$(CXX) -c -o $@ $(CXXFLAGS) $<

.h.o:
	@echo "  $< -> $@"
	@$(QT3_MOC_PATH) $< -o $<_moc.cpp
	@$(CXX) -c -pipe $(CXXFLAGS) $<_moc.cpp -o $@

im-hime.so: $(OBJS)
	@echo "linking $@ ..."
	@$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	@rm -f core.*

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(QT_IM_DIR); \
		install -m 755 im-hime.so $(QT_IM_DIR); \
	else \
		install -d $(IMMODULES); \
                install -m 755 im-hime.so $(IMMODULES); \
	fi

clean:
	@echo "clean up"
	@rm -f $(OBJS) im-hime.so *~ core.* *moc*.cpp *.E

=== src/IMdkit/lib/Makefile ===
include ../../../config.mak

#CFLAGS =  -c -O2 -fno-strength-reduce -Dlinux -D__i386__ -D_POSIX_C_SOURCE=199309L -D_POSIX_SOURCE -D_XOPEN_SOURCE=500L -D_BSD_SOURCE -D_SVID_SOURCE   -DFUNCPROTO=15 -DNARROWPROTO   -DUNIXCONN -DTCPCONN -DXIM_t -DTRANS_SERVER
CFLAGS =  -c $(OPTFLAGS) -fno-strength-reduce -DXIM_t -DTRANS_SERVER
ifeq ($(FREEBSD), 0)
  INC = -I../include -I/usr/X11R6/include
else
  INC = -I../include -I/usr/local/include/
endif

SRC = IMConn.c IMMethod.c FrameMgr.c i18nIMProto.c i18nAttr.c i18nMethod.c i18nUtil.c i18nPtHdr.c i18nIc.c i18nClbk.c i18nX.c

OBJ = $(SRC:.c=.o)

all: libXimd.a

libXimd.a: $(OBJ)
	@echo "archiving $@ ..."
	@ar cr $@ $(OBJ)
	@ranlib $@

.c.o:
	@echo "  $< -> $@"
	@$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) -c $<

clean:
	@echo "clean up"
	@rm -f libXimd.a *.o *.bak

=== debian/changelog ===
hime (0.9.10-5) unstable; urgency=medium

  * Add debian/gbp.conf
  * Conflicting struct declarations of HIME_client_handle_S (Closes: #750375)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Tue, 03 Jun 2014 19:21:44 +0800

hime (0.9.10-4) unstable; urgency=medium

  * Enable hardening build

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Wed, 07 May 2014 23:03:18 +0800

hime (0.9.10-3) unstable; urgency=medium

  * Check return value of getenv("HOME") (Closes: #716028)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Mon, 10 Mar 2014 18:07:38 +0800

hime (0.9.10-2) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * Change priority to extra because hime depends on libpango1.0-0, which is
    extra.
  * Add hime-dbg

  [ Yao Wei ]
  * Fix FTBFS on kfreebsd-* (Closes: #739735)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Mon, 24 Feb 2014 22:45:47 +0800

hime (0.9.10-1) unstable; urgency=medium

  [ Yao Wei (魏銘廷) ]
  * Imported Upstream version 0.9.10
  * debian/hime.install: update the list
  * debian/hime-data.install: remove duplicated changelog
  * debian/watch: update the url

  [ ChangZhuo Chen (陳昌倬) ]
  * Add ChangZhuo Chen (陳昌倬) as Uploaders
  * Remove DM-Upload-Allowed
  * Update Vcs-Git
  * Update debian/copyright for GFDL-1.2
  * Add keywords.patch for desktop keyword

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 20 Feb 2014 18:55:38 +0800

=== debian/control ===
Source: hime
Section: utils
Priority: extra
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders:
 Yao Wei (魏銘廷) <mwei@lxde.org>,
 ChangZhuo Chen (陳昌倬) <czchen@gmail.com>
Standards-Version: 3.9.5
Homepage: http://hime.luna.com.tw
Build-Depends: debhelper (>= 9.0.0), libgtk2.0-dev (>= 2.20.0), libgtk-3-dev,
 libqt4-dev, libchewing3-dev, libxtst-dev, libanthy-dev, autotools-dev,
 dpkg-dev (>= 1.16.1~)
Vcs-Git: git://anonscm.debian.org/pkg-ime/hime.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/hime.git;a=summary

Package: hime
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime-data, hime-tables
Recommends: im-config | im-switch, hime-gtk3-immodule
Suggests: hime-anthy, hime-chewing, hime-qt4-immodule
Description: GTK+ based input method for Chinese users
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains only GTK2 immodule. For GTK3 and Qt4 immodule, 
 please install correspondence packages.

Package: hime-data
Architecture: all
Depends: ${misc:Depends}
Description: icons, locales and scripts for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains icons, locales, scripts and other architecture-
 independent things.

Package: hime-tables
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: input method tables for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains architecture-dependent input method tables.

Package: hime-dev
Section: devel
Architecture: all
Depends: ${misc:Depends}, hime (>= ${source:Version})
Description: development files for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package provides header files of HIME.

Package: hime-qt4-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version})
Description: Qt4 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the Qt4 input method module (immodule) for HIME.

Package: hime-gtk3-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version})
Description: GTK3 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the GTK3 input method module (immodule) for HIME.

Package: hime-anthy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version}), anthy
Description: support library to use Anthy in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use anthy in HIME.

Package: hime-chewing
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version})
Description: support library to use Chewing in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use chewing in HIME.

Package: hime-dbg
Section: debug
Architecture: any
Depends: hime (= ${binary:Version}), ${misc:Depends}
Description: GTK+ based input method for Chinese users - debug files
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains only GTK2 immodule. For GTK3 and Qt4 immodule,
 please install correspondence packages.
 .
 This package contains debug symbols which are useful for debug.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@ 

override_dh_auto_clean:
	touch config.mak # dirty hack to make Makefile thinks config.mak exists
	make clean
	rm config.mak
 
override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/hime/table debian/tmp/usr/lib/hime/
	ln -s /usr/lib/hime/table debian/tmp/usr/share/hime/table

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_strip:
	dh_strip --dbg-package=hime-dbg

## hime 0.9.10%2Bgit20170427%2Bdfsg1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)


GTK2_IMMODULES := $(shell pkg-config --variable=libdir gtk+-2.0)/libgtk2.0-0/gtk-query-immodules-2.0
GTK3_IMMODULES := $(shell pkg-config --variable=libdir gtk+-3.0)/libgtk-3-0/gtk-query-immodules-3.0

%:
	dh $@ --no-parallel

override_dh_auto_clean:
	touch config.mak # dirty hack to make Makefile thinks config.mak exists
	make clean
	rm config.mak

override_dh_auto_configure:
	dh_auto_configure -- \
		--himelibdir=/usr/lib/$(DEB_HOST_MULTIARCH)/hime \
		--qt4-moc-path="qtchooser -run-tool=moc -qt=4" \
		--qt5-moc-path="qtchooser -run-tool=moc -qt=5" \
		$(NULL)

	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK2_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postinst.in > $(CURDIR)/debian/hime-gtk2-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK2_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postrm.in > $(CURDIR)/debian/hime-gtk2-immodule.postrm
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postinst.in > $(CURDIR)/debian/hime-gtk3-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postrm.in > $(CURDIR)/debian/hime-gtk3-immodule.postrm
 
override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/hime/table debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/hime/table
	ln -s /usr/lib/$(DEB_HOST_MULTIARCH)/hime/table debian/tmp/usr/share/hime/table

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_strip:
	dh_strip --ddeb-migration='hime-dbg (<< 0.9.10+git20150916+dfsg1-2~)'

override_dh_install:
	dh_install \
		--exclude=usr/include/hime-im-client-attr.h \
		--exclude=usr/include/hime-im-client.h \
		--exclude=usr/share/doc/hime/ChangeLog \
		--fail-missing
